%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Weight = Shell_Element_Weight(Fastener_Index, Layer, Element_ID)

global ErrCode;
global DB_FASTENERS;

Weight = [];

switch DB_FASTENERS{Fastener_Index}.Joint_topology{Layer}

    case 'plate'
        
        Node = DB_FASTENERS{Fastener_Index}.Joint_nodes(Layer);
        
        N_Elements = size(DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.Element_list,1);
        
        Angle_Sum = 0;
        
        for j=1:N_Elements
            
            Angle_Sum = Angle_Sum + Shell_Element_Angle(Node, DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.Element_list(j));
            
            if (ErrCode < 0)
                return;
            end
            
        end
        
        Current_Angle = Shell_Element_Angle(Node, Element_ID);
        
        if (ErrCode < 0)
            return;
        end
        
        Weight = Current_Angle / Angle_Sum;
        
    case 'plate_rbe2_sequential'
        
        [Test_Result, Center_Node_ID] = Plate_RBE2_Seq_Centered_Test(Fastener_Index, Layer);
        
        if (ErrCode < 0)
            return;
        end
        
        if (Test_Result == 1)
            
            Node = Center_Node_ID;
            Elm_list = DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.Element_list;
            N_Elements = size(Elm_list,1);
            
        else
            
            fprintf (1, '\nОшибка функции Shell_Element_Weight: аргументы функции ссылаются на нецентрированную присоединенную топологию типа [%s] !\n', DB_FASTENERS{Fastener_Index}.Joint_topology{Layer});
            ErrCode = -1;
            return;
            
        end
        
        Angle_Sum = 0;
        
        for j=1:N_Elements
            
            Angle_Sum = Angle_Sum + Shell_Element_Angle(Node, Elm_list(j));
            
            if (ErrCode < 0)
                return;
            end
            
        end
        
        Current_Angle = Shell_Element_Angle(Node, Element_ID);
        
        if (ErrCode < 0)
            return;
        end
        
        Weight = Current_Angle / Angle_Sum;
        
    case 'plate_rbe2_parallel'
        
        Node = DB_FASTENERS{Fastener_Index}.Joint_nodes(Layer);
        
        Elm_list = DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.Element_list;
        
        N_Elements = size(Elm_list,1);
        
        Angle_Sum = 0;
        
        for j=1:N_Elements
            
            Angle_Sum = Angle_Sum + Shell_Element_Angle(Node, Elm_list(j));
            
            if (ErrCode < 0)
                return;
            end
            
        end
        
        Current_Angle = Shell_Element_Angle(Node, Element_ID);
        
        if (ErrCode < 0)
            return;
        end
        
        Weight = Current_Angle / Angle_Sum;
        
    case {'rbe2_2d_hole', 'bar_spider_2d_hole', 'rbe2_3d_hole', 'bar_spider_3d_hole'}

        fprintf (1, '\nОшибка функции Shell_Element_Weight: аргументы функции ссылаются на неправильный тип присоединенной топологии [%s] !\n', DB_FASTENERS{Fastener_Index}.Joint_topology{Layer});
        ErrCode = -1;
        return;

    otherwise

        fprintf (1, '\nОшибка функции Shell_Element_Weight: неизвестный тип присоединенной топологии [%s] в болте %i !\n', DB_FASTENERS{Fastener_Index}.Joint_topology{Layer}, Fastener_Index);
        ErrCode = -1;
        return;

end
